from setuptools import setup, find_packages

VERSION = '0.0.1'
Description = 'A simple python package for training your Code Assistant LLM.'
Long_Description = '''
This package is developed by EnigmaAI for the Deepfund Platform. It provides a simple interface for training your Code Assistant LLM.
First it allows you to scrape GitHub repositories for code based on a search query and vaiours filters for code quality and license.
Second it allows you to train your LLM on the scraped code. This can be highly customized to your needs and the type of code you want to generate.
It allows for the choice of different models from the HuggingFace library and the choice of different Efficent fine-tuning strategies.
'''

setup(
    name='deepfund-code-assistant',
    version=VERSION,
    author='EnigmaAI',
    author_email= 'ammarnasraza@gmail.com',
    description=Description,
    long_description=Long_Description,
    packages=find_packages(),
    install_requires=[], # Add any necessary dependencies here,
    keywords=['python', 'deepfund', 'code', 'assistant', 'llm'],
    classifiers=[
        "Programming Language :: Python :: 3",
        "Operating System :: OS Independent",
    ],
)


